package entity

type UserLogDailyResp struct {
	Platform    string  `bson:"platform"  json:"platform"`        // platform: 用户所在的平台，例如“Android”或“IOS”
	Channel     string  `bson:"channel" json:"channel"`           // channel: 用户来源渠道
	Registered  int     `bson:"registered" json:"registered"`     // registered: 新用户注册的数量
	LoggedIn    int     `bson:"logged_in" json:"logged_in"`       // logged_in: 登陆产品的用户数量
	NewLogin    int     `bson:"new_login" json:"new_login"`       // new_login: 登陆产品的新注册用户数量
	OldLogin    int     `bson:"old_login" json:"old_login"`       // old_login: 登陆产品的老用户数量
	ActiveUsers int     `bson:"active_users" json:"active_users"` // active_users: 登录游戏后投掷过骰子的用户数量
	NewActive   int     `bson:"new_active" json:"new_active"`     // new_active: 登录游戏后投掷过骰子的新用户数量
	OldActive   int     `bson:"old_active" json:"old_active"`     // old_active: 登录游戏后投掷过骰子的老用户数量
	TotalPoints int     `bson:"total_points" json:"total_points"` // total_points: 全服积分产出总值
	UProduced   float64 `bson:"u_produced" json:"u_produced"`     // u_produced: 全服U的产出总值
	UCashout    float64 `bson:"u_cashout" json:"u_cashout"`       // u_cashout: 全服U的提现总值
	Timestamp   int64   `bson:"daily" json:"timestamp"`           // timestamp: 数据记录的时间戳
}

// UserLogDailyReq 用户日志
type UserLogDailyReq struct {
	Platform  string `json:"platform"`
	StartTime int64  `json:"start_time"`
	EndTime   int64  `json:"end_time"`
	Channel   string `json:"channel"`
	Page      int    `json:"page"`
	Size      int    `json:"size"`
}
