package router

import (
	"net/http"

	"github.com/gin-gonic/gin"
	mhayaGin "github.com/mhaya/components/gin"
	cfacade "github.com/mhaya/facade"
	"github.com/mhaya/game/game_cluster/nodes/webadmin/controller"
)

type Controller struct {
	mhayaGin.BaseController
}

func (c *Controller) Init() {
	c.SetRouter()
}

// CreateUserController 创建用户的控制
func (c *Controller) CreateUserController() {
	// parentActor := &user.User{}
	// c.CreateActor(parentActor.AliasID(), parentActor)
}

func (c *Controller) CreateActor(id string, handler cfacade.IActorHandler) {
	// system := bcwinActor.NewSystem()
	// system.SetApp(c.App)
	// system.CreateActor(id, handler)
}

// SetRouter 设置路由
func (c *Controller) SetRouter() {
	group := c.Group("/")
	u := group.Group("/v1/admin")
	c.InitApiRouter(u)
}

func (c *Controller) InitApiRouter(u *gin.RouterGroup) {
	u.GET("/hello", func(context *gin.Context) {
		context.JSON(http.StatusOK, "")
	})
	u.POST("/user/log/daily", controller.NewSynthesis().FindUserLogDaily)
	u.POST("/user/retention", controller.NewSynthesis().FindUserRetention)
	u.POST("/user/country", controller.NewSynthesis().FindUserCountryCount)
	u.POST("/user/withdrawal", controller.NewSynthesis().FindWithdrawal)
	u.POST("/user/withdrawal/status", controller.NewSynthesis().WithdrawalStatus)
	u.POST("/user/level", controller.NewSynthesis().FindUserLevel)

}

// func (c *Controller) InitMdb() {
// 	MdbAdmin, _ = mdb.InitializeMongoDB()
// }
